/***************************************************************************
 *   Copyright (C) 2010 by                                                 *
 *                                                                         *
 *   catWorkX GmbH, Schellerdamm 16, 21079 Hamburg                         *
 *   Sebastian Gerdes <sebastian.gerdes_AT_catworkx.de>                    *
 *                                                                         *
 *   This code is part of the Jira2Zarafa Plugin, which is able to add an  *
 *   all-day appointment in Zarafa. This all-day appointment will be added *
 *   when you set a due date and an assignee in a Jira issue.              *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Affero General Public License as        *
 *   published by the Free Software Foundation; either version 3           *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          *
 *   GNU AFFERO GENERAL PUBLIC LICENSE for more details.                   *
 *                                                                         *
 *   You should have received a copy of the GNU Affero General Public      *
 *   License along with this program.  If not, see                         *
 *   <http://www.gnu.org/licenses/>                                        *
 *                                                                         *
 ***************************************************************************/
 

package de.catworkx.jira.plugin.zarafa;

public class MapiConnect {

	AppointmentSOAPBindingStub mapi = null;
	
	public MapiConnect(String address) {
		try {
			AppointmentSOAPLocator serviceLocator = new AppointmentSOAPLocator();
			serviceLocator.setappointmentSOAPPortEndpointAddress(address);
			AppointmentSOAPBindingStub server = (AppointmentSOAPBindingStub)serviceLocator.getappointmentSOAPPort();
			System.out.println("");
			this.mapi = server;
		} catch (Exception e) {
			e.printStackTrace();
		}	
	}
	
	public void setAppointment(String username, String subject, String startdate, String body) {
		try {
			this.mapi.addAppointment(username, subject, startdate, body);
		} catch (Exception e) {
			e.printStackTrace();
		}
		
	}
	
	public void delAppointment(String username, String subject, String startdate) {
		try {
			this.mapi.delAppointment(username, subject, startdate);
		} catch (Exception e) {
			e.printStackTrace();
		}
		
	}
	
}
