<?php
/**
 * Zarafa Jira Plugin
 *
 * Author: Sebastian Gerdes <sebastian.gerdes_AT_catworkx.de>
 *
 */

$username = $_SESSION["username"];
$password = $_SESSION["password"];
$session = $GLOBALS["mapisession"]->getSession();

$defaults = getDefaults();
$wsdl = $defaults['jira_wsdl'];

function getDialogTitle() {
	return "Create Jira Issue";
}

function getDefaults() {
        return $GLOBALS['pluginconfig']['cwxjira']['defaults'];
}

function getBody(){
	global $username, $password, $session, $wsdl;

	if (isset($_GET["action"]))
		createJiraIssue();
	else {
		if (!isset($_GET["storeid"]))
			die("Missing storeid parameter.");
		if (!isset($_GET["entryid"]))
			die("Missing entryid parameter.");
		
		$storeid = hex2bin($_GET["storeid"]);
		$entryid = hex2bin($_GET["entryid"]);
		
		
		// open userstore
		$stores = mapi_getmsgstorestable($session);
		$storeslist = mapi_table_queryallrows($stores);
		$userstore = mapi_openmsgstore($session, $storeslist[0][PR_ENTRYID]);
		
		// open MAPI (email) message
		$message = mapi_msgstore_openentry($userstore, $entryid);
		
		// retrieve subject and body of the email message
		if ( $message != NULL) {
			$msgcontent = mapi_getprops($message, array(PR_SUBJECT, PR_BODY));
			$mail_subject = iconv("Windows-1252","UTF-8",$msgcontent[PR_SUBJECT]);
			$mail_body = iconv("Windows-1252","UTF-8",$msgcontent[PR_BODY]);
		} else {
			die("Could not open MAPI Message!");
		}
		
		// SOAP call to Jira
		try {
			$soap   = new SoapClient($wsdl);
			$auth   = $soap->login($username, $password);
			$projects = array();
			// get names and IDs of all projects and their issuetypes
			if ($auth) {
				$soapprojects = $soap->getProjectsNoSchemes($auth);
				foreach ($soapprojects as $pro) {
					$projects["key"][] = $pro->key;
					$projects[$pro->key]["name"] = $pro->name;
					$soapissuetypes = $soap->getIssueTypesForProject($auth, $pro->id);
					$issuetypes = array();
					foreach ($soapissuetypes as $it) {
						$issuetypes[$it->id] = $it->name;
					}
					$projects[$pro->key]["issuetypes"] = $issuetypes;
				}
				// logout again
				$soap->logout($username);
				
				?>
<script type="text/JavaScript">
 $(document).ready(function()	{

	var selectoptions = {
		<?php
		foreach ($projects["key"] as $pid ) {
			echo '"'.$projects[$pid]["name"].'": {
				"key" : "'.$pid.'",
				"values" : {';
				foreach ($projects[$pid]["issuetypes"] as $itkey => $itvalue) {
					echo '"'.$itvalue.'" : '.$itkey.',';
				}
			echo '}},';
		}	
		?>
	};
	
	var options = {emptyOption: true};
	    $('#projectid').doubleSelect('issuetypeid', selectoptions, options);
 });
</script>

				<form method="post" action="index.php?load=dialog&task=jiraprojects&plugin=cwxjira&action=create">
				
				<table border="0"  width="400" cellpadding="3" cellspacing="1">
				<tr><td>Select project:</td><td>
	
				<select name="project" id="projectid">
				<option value="">--</option>
				</select></td></tr>
			
				<tr><td>Select issue type:</td><td>
				<select name="issuetype" id="issuetypeid">
				<option value="">--</option>
				</select></td></tr>
		
				<tr><td>Subject:</td><td>
				<input type="text" name="subject" value="<? echo $mail_subject?>"/></td></tr>
				</table><br />

				<textarea rows="25" cols="110" name="description"><? echo $mail_body ?></textarea><br>
				
				<input type="submit" value="Create Jira Issue" />	
		
				</form>
			<?php
			} else {
				echo "ERROR: Cannot log in!";
			}
		
		} catch(Exception $e){
			echo 'Could not connect to Jira. Error: '.$e->getMessage().'<br /><br /><button onclick="window.close()">Close Window</button>';
		}
	}
}

// this function is called on 'submit'
function createJiraIssue () {
	global $username, $password, $session, $wsdl;
	$project = $_POST["project"];
	$issuetype = $_POST["issuetype"];
	$subject = $_POST["subject"];
	$body = $_POST["description"];

	try {
		$soap   = new SoapClient($wsdl);
		$auth   = $soap->login($username, $password);
		$projects = array();
		// create the issue
		if ($auth) {
			$rIssue="";
			$rIssue['project'] = $project;
			$rIssue['type'] = $issuetype;
			$rIssue['summary'] = $subject;
			$rIssue['description'] = $body;
			//$rIssue['priority'] = "1";
			//$rIssue['reporter'] = $username;
			//$rIssue['assignee'] = $username;

			$issue = $soap->createIssue($auth, $rIssue);
		}

		$soap->logout($username);
		echo 'The issue has been created!<br /><br /><button onclick="window.close()">Close Window</button>';
	
	} catch (Exception $e){
		echo 'The issue could not be created. Error: '.$e->getMessage().'<br /><br /><button onclick="window.close()">Close Window</button>';
	}
}

?>
